<?php
// +-----------------------------------------------------------------------+
// | Mod Name : CopyThumbnails                                             |
// | Mod Version : 1.2                                                     |
// | Mod Version author : FlipFlip <flipflip@free.fr>                      |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

class CopyThumbnails {
  var $plugin_name, $plugin_path, $plugin_url;
  var $my_config;

  function CopyThumbnails($plugin_name, $plugin_path, $plugin_url) {
    // Args
    $this->plugin_name = $plugin_name;
    $this->plugin_path = $plugin_path;
    $this->plugin_url = $plugin_url;
    // handler
    $this->initialize_event_handler($plugin_name, $plugin_path, $plugin_url);
  }

  function initialize_event_handler() {
    $this->load_config(); // Chargement de la configuration
    $this->load_lang(); // Chargement des langues
  
    add_event_handler('add_elements', array(&$this, 'CopieImages'));
    
    // Ajouter un trigger dans le fichier admin/include/functions.php
    // Au début de la fonction delete_elements
    add_event_handler('begin_delete_elements', array(&$this, 'SupprimeImages'));
    
    if (is_admin()) {
      // ---- Administration
      add_event_handler('get_admin_plugin_menu_links', array(&$this, 'plugin_admin_menu')); // Menu d'administration
    }    
  }

  /* this function initialize var $my_config with default values */
  function init_config() {
    $this->my_config = array();
  }
  
  function load_config() {
    $this->init_config();
    
    $query = '
      SELECT value 
      FROM '.CONFIG_TABLE.'
      WHERE param = \'copythumbnails_config\'
    ;';
    
    $result = pwg_query($query);
   
    if($result) {
      $row = mysql_fetch_row($result);
      if(is_string($row[0])) {
        $config = unserialize($row[0]);
        reset($config);
        while (list($key, $val) = each($config)) {
          $this->my_config[$key] = $val;
        }
      }
    }  	
  }

  // Affichage du lien dans la barre
  // menu administrateur
  function plugin_admin_menu($menu) {
    array_push($menu,
      array(
        'NAME' => 'Copy Thumbnails',
        'URL' => get_admin_plugin_menu_link($this->plugin_path.'admin/CpThumbnailsAdmin.php')
      )
    );
    return $menu;
  }
  
  // Sauvegarde de la configuration
  function save_config() {
    $query = '
      REPLACE INTO '.CONFIG_TABLE.' 
      VALUES(
        \'copythumbnails_config\',
        \''.serialize($this->my_config).'\',
        \'Configuration de CopyThumbnails\')
    ;';
       
    $result = pwg_query($query);
    
    if($result) {
      return true;
    } else {
      return false;
    }  	
  }
  
  // Chargement des fichiers langues
  function load_lang() {
    load_language('plugin.lang', $this->plugin_path);
  }
    
  // Copie les fichiers dans le répertoire définit dans le fichier
  function CopieImages($inserts) {
  	global $conf;

  	$exts = array('pdf', 'PDF', 'xls', 'XLS', 'doc', 'DOC', 'pps', 'PPS', 'ppt', 'PPT', 'ai', 'AI', 'eps', 'EPS', 'wmv', 'WMV', 'wma', 'WMA', 'mpg', 'MPG', 'mpeg', 'MPEG');
  	
  	foreach ($inserts as $cle => $file) {
  	  $dir = dirname($file['path']);
      $ext = explode('.', $file['file']);

      if(!in_array($ext[1], $exts)) {
  	    if(file_exists($this->plugin_path.$this->my_config['repertoire'].'/'.$conf['prefix_thumbnail'].$file['file'])) {
          unlink($this->plugin_path.$this->my_config['repertoire'].'/'.$conf['prefix_thumbnail'].$file['file']);
        }

        // Copie de la vignette
        copy(
          $dir.'/thumbnail/'.$conf['prefix_thumbnail'].$file['file'],
          $this->plugin_path.$this->my_config['repertoire'].'/'.$conf['prefix_thumbnail'].$file['file']
        );
      }
  	}	
  }

  // Supprime les fichiers non présent dans la base
  // $ids -> identifiant des images à supprimer
  function SupprimeImages($ids) {
  	global $conf;
   	
    $query = '
      SELECT file FROM '.IMAGES_TABLE.'
      WHERE id IN(
        '.wordwrap(implode(', ', $ids), 80, "\n").')
      ;';
    $result = pwg_query($query);
    
    while($row = mysql_fetch_array ($result)) {
      if(file_exists($this->plugin_path.$this->my_config['repertoire'].'/'.$conf['prefix_thumbnail'].$row['file'])) {
        unlink($this->plugin_path.$this->my_config['repertoire'].'/'.$conf['prefix_thumbnail'].$row['file']);
      }
    }
  }
}
?>